package org.etsi.mts.tdl.graphical.extensions;

import java.util.List;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.serializer.impl.Serializer;
import org.etsi.mts.tdl.ActionReference;
import org.etsi.mts.tdl.Assertion;
import org.etsi.mts.tdl.ComponentInstanceBinding;
import org.etsi.mts.tdl.DataInstanceUse;
import org.etsi.mts.tdl.DataUse;
import org.etsi.mts.tdl.ParameterBinding;
import org.etsi.mts.tdl.TestDescriptionReference;
import org.etsi.mts.tdl.graphical.labels.DataStandaloneSetup;

import com.google.inject.Injector;

public class DataUseLabelProvider {

	public String separator(EObject o, List<String> c, String s) {
		String output = "";
		for (String e : c) {
			output+=s+e;
		}
		if (c.size()>0) {
			return output.substring(s.length());
		}
		return output;
	}

	@SuppressWarnings("restriction")
	public String serialise(EObject o, ActionReference u, String separator) {
		Injector injector = new DataStandaloneSetup().createInjectorAndDoEMFRegistration();
		String s = "";
		Serializer serializer = injector.getInstance(Serializer.class); 

		try {  
			if (u instanceof ActionReference) {
				for (DataUse b : ((ActionReference)u).getActualParameter()) {
					s+=separator+serializer.serialize(b);
				}
				if (s.length()>0) {
					s=s.substring(separator.length());
					s="("+s+")";
				}
			}
		} catch (Exception ex) { // fall back:  
			System.out.println("Object could not be serialized"); 
			System.out.println(ex.getMessage());
			ex.printStackTrace();
		}  
		
		return s;
	}

	
	@SuppressWarnings("restriction")
	public String serialise(EObject o, TestDescriptionReference u, String type, String separator) {
		Injector injector = new DataStandaloneSetup().createInjectorAndDoEMFRegistration();
		String s = "";
		Serializer serializer = injector.getInstance(Serializer.class); 

		try {  
			if (u instanceof TestDescriptionReference) {
				if (type.equals("bindings")) {
					for (ComponentInstanceBinding b : ((TestDescriptionReference)u).getComponentInstanceBinding()) {
						s+=separator+serializer.serialize(b);
					}
					if (s.length()>0) {
						s=s.substring(separator.length());
					}
				} else if (type.equals("parameters")) {
					for (DataUse b : ((TestDescriptionReference)u).getActualParameter()) {
						s+=separator+serializer.serialize(b);
					}
					if (s.length()>0) {
						s=s.substring(separator.length());
						s="("+s+")";
					}
					
				} else {
					s += "Unsupported type argument";
				}
			}
		} catch (Exception ex) { // fall back:  
			System.out.println("Object could not be serialized"); 
			System.out.println(ex.getMessage());
			ex.printStackTrace();
		}  
		
		return s;
	}

	@SuppressWarnings("restriction")
	public String serialise(EObject o, DataUse u) {
		Injector injector = new DataStandaloneSetup().createInjectorAndDoEMFRegistration();
		String s = "";
		Serializer serializer = injector.getInstance(Serializer.class); 

		try {  
			if (u instanceof DataUse) {
				s += serializer.serialize((DataUse)u);  
			}
		} catch (Exception ex) { // fall back:  
			System.out.println("Object could not be serialized"); 
			System.out.println(ex.getMessage());
			ex.printStackTrace();
		}  
		
		return s;
	}

	
	public String getDataUse(EObject o, DataUse u, String s) {
		String output = ""+u.eClass().getName();
		if (u instanceof DataInstanceUse) {
			DataInstanceUse d = (DataInstanceUse) u;
			output = d.getDataInstance().getName();
			if (d.getArgument().size()>0) {
				output+="(";
				for (ParameterBinding p : d.getArgument()) {
					output+=p.getParameter().getName()+" := ";
					getDataUse(d, p.getDataUse(), s);
				}
				output+=")";
			}
		} else {
			output+=" (not yet implemented)";
		}
		//output += 
		return output;
	}

}
